作者: KSkun

[洛谷3674]小清新人渣的本愿 题解

[洛谷3674]小清新人渣的本愿 题解

题目地址:洛谷:【P3674】小清新人渣的本愿 – 洛谷 题目描述 给你一个序 

[BZOJ3781]小B的询问 题解

[BZOJ3781]小B的询问 题解

题目地址:洛谷:【P2709】小B的询问 – 洛谷、BZOJ:Problem  

[国家集训队]小Z的袜子 题解

[国家集训队]小Z的袜子 题解

题目地址:洛谷:【P1494】[国家集训队]小Z的袜子 – 洛谷、BZOJ:Problem 2038. — [2009国家集训队]小Z的袜子(hose)

题目描述

作为一个生活散漫的人,小Z每天早上都要耗费很久从一堆五颜六色的袜子中找出一双来穿。终于有一天,小Z再也无法忍受这恼人的找袜子过程,于是他决定听天由命……
具体来说,小Z把这N只袜子从1到N编号,然后从编号L到R(L 尽管小Z并不在意两只袜子是不是完整的一双,甚至不在意两只袜子是否一左一右,他却很在意袜子的颜色,毕竟穿两只不同色的袜子会很尴尬。
你的任务便是告诉小Z,他有多大的概率抽到两只颜色相同的袜子。当然,小Z希望这个概率尽量高,所以他可能会询问多个(L,R)以方便自己选择。
然而数据中有L=R的情况,请特判这种情况,输出0/1。

题意简述

有一个颜色序列,每次询问给出一个区间,求从区间中任选两个位置颜色相同的概率,要求输出最简分数。

输入输出格式

输入格式:
输入文件第一行包含两个正整数N和M。N为袜子的数量,M为小Z所提的询问的数量。接下来一行包含N个正整数Ci,其中Ci表示第i只袜子的颜色,相同的颜色用相同的数字表示。再接下来M行,每行两个正整数L,R表示一个询问。

输出格式:
包含M行,对于每个询问在一行中输出分数A/B表示从该询问的区间[L,R]中随机抽出两只袜子颜色相同的概率。若该概率为0则输出0/1,否则输出的A/B必须为最简分数。(详见样例)

输入输出样例

输入样例#1:

6 4
1 2 3 3 3 2
2 6
1 3
3 5
1 6

输出样例#1:

2/5
0/1
1/1
4/15

说明

30%的数据中 N,M ≤ 5000;
60%的数据中 N,M ≤ 25000;
100%的数据中 N,M ≤ 50000,1 ≤ L < R ≤ N,Ci ≤ N。

题解

参考资料:【莫队算法】 – 大米饼 – 博客园
第一次写莫队。
我们考虑离线解决这个问题。发现对于每个询问的答案,我们可以用O(1)时间在[l, r]区间和[l±1, r]或[l, r±1]这些区间之间转移。此时,我们考虑将询问分块,按照左端点的块号与右端点双关键字排序。这样,我们可以获得在相邻询问之间转移答案的最高效率,实现O(n \sqrt{n})的复杂度。
具体而言,对于本题,分母显然就是len(len-1),而分子是每种颜色的数量平方和-len。我们维护一下区间每种颜色的数量及其平方和,某颜色数量更改时顺便更新平方和即可。

代码

// Code by KSkun, 2018/6
#include <cstdio>
#include <cctype>
#include <cmath>

#include <algorithm>

typedef long long LL;

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2) 
        ? EOF : *p1++;
}

inline LL readint() {
    register LL res = 0, neg = 1;
    register char c = fgc();
    while(!isdigit(c)) {
        if(c == '-') neg = -1;
        c = fgc();
    }
    while(isdigit(c)) {
        res = (res << 1) + (res << 3) + c - '0';
        c = fgc();
    }
    return res * neg;
}

const int MAXN = 50005;

inline LL gcd(LL a, LL b) {
    if(!b) return a;
    return gcd(b, a % b);
}

int n, m, block, col[MAXN], ccnt[MAXN];
LL ans1[MAXN], ans2[MAXN], now;

inline int bid(int pos) {
    return pos / block + 1;
}

inline void apply(int pos, int add) {
    now -= 1ll * ccnt[col[pos]] * ccnt[col[pos]];
    ccnt[col[pos]] += add;
    now += 1ll * ccnt[col[pos]] * ccnt[col[pos]];
}

struct Query {
    int l, r, id;
} qur[MAXN];

inline bool cmp(Query a, Query b) {
    return bid(a.l) == bid(b.l) ? a.r < b.r : a.l < b.l;
}

int main() {
    n = readint(); m = readint(); block = sqrt(n);
    for(int i = 1; i <= n; i++) {
        col[i] = readint();
    }
    for(int i = 1; i <= m; i++) {
        qur[i].l = readint(); qur[i].r = readint(); qur[i].id = i;
    }
    std::sort(qur + 1, qur + m + 1, cmp);
    int l = 1, r = 0;
    for(int i = 1; i <= m; i++) {
        for(; l < qur[i].l; l++) apply(l, -1);
        for(; l > qur[i].l; l--) apply(l - 1, 1);
        for(; r < qur[i].r; r++) apply(r + 1, 1);
        for(; r > qur[i].r; r--) apply(r, -1);
        if(qur[i].l == qur[i].r) {
            ans1[qur[i].id] = 0; ans2[qur[i].id] = 1; continue;
        }
        ans1[qur[i].id] = now - (qur[i].r - qur[i].l + 1);
        ans2[qur[i].id] = 1ll * (qur[i].r - qur[i].l + 1) * (qur[i].r - qur[i].l);
        LL g = gcd(ans1[qur[i].id], ans2[qur[i].id]); 
        ans1[qur[i].id] /= g; ans2[qur[i].id] /= g;
    }
    for(int i = 1; i <= m; i++) {
        printf("%lld/%lld\n", ans1[i], ans2[i]);
    }
    return 0;
}
[CQOI2015]选数 题解

[CQOI2015]选数 题解

题目地址:洛谷:【P3172】[CQOI2015]选数 – 洛谷、BZOJ:P 

[SDOI2015]约数个数和 题解

[SDOI2015]约数个数和 题解

题目地址:洛谷:【P3327】[SDOI2015]约数个数和 – 洛谷、BZO 

[HAOI2011]Problem b 题解

[HAOI2011]Problem b 题解

题目地址:洛谷:【P2522】[HAOI2011]Problem b – 洛谷、BZOJ:Problem 2301. — [HAOI2011]Problem b

题目描述

对于给出的n个询问,每次求有多少个数对(x,y),满足a≤x≤b,c≤y≤d,且gcd(x,y) = k,gcd(x,y)函数为x和y的最大公约数。

输入输出格式

输入格式:
第一行一个整数n,接下来n行每行五个整数,分别表示a、b、c、d、k

输出格式:
共n行,每行一个整数表示满足要求的数对(x,y)的个数

输入输出样例

输入样例#1:

2
2 5 1 5 1
1 5 1 5 2

输出样例#1:

14
3

说明

100%的数据满足:1≤n≤50000,1≤a≤b≤50000,1≤c≤d≤50000,1≤k≤50000

题解

这个题[POI2007]ZAP-QUERIES的一个强化版。我们考虑使用容斥原理,答案即ans([1, b], [1, d])-ans([1, a-1], [1, d])-ans([1, b], [1, c-1])+ans([1, a-1], [1, c-1])。
总复杂度O(n \sqrt{n})

代码

// Code by KSkun, 2018/6
#include <cstdio>
#include <cctype>  

#include <algorithm>

typedef long long LL;

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2) 
        ? EOF : *p1++;
}

inline LL readint() {
    register LL res = 0, neg = 1;
    register char c = fgc();
    while(!isdigit(c)) {
        if(c == '-') neg = -1;
        c = fgc();
    }
    while(isdigit(c)) {
        res = (res << 1) + (res << 3) + c - '0';
        c = fgc();
    }
    return res * neg;
}

const int MAXN = 50005;

bool notprime[MAXN];
int prime[MAXN], miu[MAXN], ptot;

inline void sieve() {
    miu[1] = 1;
    for(int i = 2; i < MAXN; i++) {
        if(!notprime[i]) {
            prime[ptot++] = i;
            miu[i] = -1;
        }
        for(int j = 0; j < ptot && prime[j] * i < MAXN; j++) {
            int k = prime[j] * i;
            notprime[k] = true;
            if(i % prime[j] == 0) {
                miu[k] = 0; break;
            } else {
                miu[k] = -miu[i];
            }
        }
    }
    for(int i = 2; i < MAXN; i++) {
        miu[i] += miu[i - 1];
    }
}

inline LL cal(int b, int d, int k) {
    LL all = 0;
    if(!k) return 0;
    b /= k; d /= k;
    if(b > d) std::swap(b, d);
    for(int i = 1; i <= b;) {
        int j = std::min(b / (b / i), d / (d / i));
        all += 1ll * (miu[j] - miu[i - 1]) * (b / i) * (d / i);
        i = j + 1;
    }
    return all;
}

int T, a, b, c, d, k;

int main() {
    sieve();
    T = readint();
    while(T--) {
        a = readint(); b = readint(); c = readint(); d = readint(); k = readint();
        printf("%lld\n", cal(b, d, k) - cal(a - 1, d, k) - cal(b, c - 1, k) 
            + cal(a - 1, c - 1, k));
    }
    return 0;
}
[POI2007]ZAP-Queries 题解

[POI2007]ZAP-Queries 题解

题目地址:洛谷:【P3455】[POI2007]ZAP-Queries – 洛 

[洛谷2664]树上游戏 题解

[洛谷2664]树上游戏 题解

题目地址:洛谷:【P2664】树上游戏 – 洛谷 题目描述 lrb有一棵树,树 

[SCOI2016]幸运数字 题解

[SCOI2016]幸运数字 题解

题目地址:洛谷:【P3292】[SCOI2016]幸运数字 – 洛谷、BZOJ:Problem 4568. — [Scoi2016]幸运数字

题目描述

A 国共有 n 座城市,这些城市由 n-1 条道路相连,使得任意两座城市可以互达,且路径唯一。每座城市都有一个幸运数字,以纪念碑的形式矗立在这座城市的正中心,作为城市的象征。
一些旅行者希望游览 A 国。旅行者计划乘飞机降落在 x 号城市,沿着 x 号城市到 y 号城市之间那条唯一的路径游览,最终从 y 城市起飞离开 A 国。在经过每一座城市时,游览者就会有机会与这座城市的幸运数字拍照,从而将这份幸运保存到自己身上。然而,幸运是不能简单叠加的,这一点游览者也十分清楚。他们迷信着幸运数字是以异或的方式保留在自己身上的。
例如,游览者拍了 3 张照片,幸运值分别是 5,7,11,那么最终保留在自己身上的幸运值就是 9(5 xor 7 xor 11)。
有些聪明的游览者发现,只要选择性地进行拍照,便能获得更大的幸运值。例如在上述三个幸运值中,只选择 5 和 11 ,可以保留的幸运值为 14 。现在,一些游览者找到了聪明的你,希望你帮他们计算出在他们的行程安排中可以保留的最大幸运值是多少。

题意简述

给一棵树,每个点有权值,求两点间路径上所有点的权值取若干个求异或和的最大值。

输入输出格式

输入格式:
第一行包含 2 个正整数 n ,q,分别表示城市的数量和旅行者数量。
第二行包含 n 个非负整数,其中第 i 个整数 Gi 表示 i 号城市的幸运值。
随后 n-1 行,每行包含两个正整数 x ,y,表示 x 号城市和 y 号城市之间有一条道路相连。
随后 q 行,每行包含两个正整数 x ,y,表示这名旅行者的旅行计划是从 x 号城市到 y 号城市。N<=20000,Q<=200000,Gi<=2^60

输出格式:
输出需要包含 q 行,每行包含 1 个非负整数,表示这名旅行者可以保留的最大幸运值。

输入输出样例

输入样例#1:

4 2
11 5 7 9
1 2
1 3
1 4
2 3
1 4

输出样例#1:

14 
11

题解

把线性基搞树上去了,我们自然要在树上维护线性基。我们考虑使用倍增法求LCA,并把一个点到它所有倍增父亲这一段路径的线性基预处理出来,在倍增上跳的过程中就是O(\log n)次合并线性基的过程。
倍增LCAO(\log n),维护线性基O(\log n),合并线性基O(\log^2 n),因此总复杂度O(n \log^3 n)

代码

// Code by KSkun, 2018/5
#include <cstdio>
#include <cctype>  
#include <cstring>

#include <algorithm>
#include <vector>

typedef long long LL;

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2) 
        ? EOF : *p1++;
}

inline LL readint() {
    register LL res = 0, neg = 1;
    register char c = fgc();
    while(!isdigit(c)) {
        if(c == '-') neg = -1;
        c = fgc();
    }
    while(isdigit(c)) {
        res = (res << 1) + (res << 3) + c - '0';
        c = fgc();
    }
    return res * neg;
}

const int MAXN = 20005;

std::vector<int> gra[MAXN];

struct LinearBasis {
    LL mat[65];
    LinearBasis() {
        memset(mat, 0, sizeof(mat));
    }
    inline void insert(LL x) {
        for(int i = 60; i >= 0; i--) {
            if(x & (1ll << i)) {
                if(!mat[i]) {
                    mat[i] = x; break;
                } else {
                    x ^= mat[i];
                }
            }
        }
    }
    inline void merge(LinearBasis &x) {
        for(int i = 60; i >= 0; i--) {
            if(x.mat[i]) insert(x.mat[i]);
        }
    }
    inline LL max() {
        LL res = 0;
        for(int i = 60; i >= 0; i--) {
            res = std::max(res, res ^ mat[i]);
        }
        return res;
    }
} lb[MAXN][20];

int anc[MAXN][20], dep[MAXN];
LL w[MAXN];

inline void dfs(int u) {
    for(int i = 1; i < 15; i++) {
        anc[u][i] = anc[anc[u][i - 1]][i - 1];
        lb[u][i].merge(lb[u][i - 1]);
        lb[u][i].merge(lb[anc[u][i - 1]][i - 1]);
    }
    for(int i = 0; i < gra[u].size(); i++) {
        int v = gra[u][i];
        if(v == anc[u][0]) continue;
        anc[v][0] = u;
        dep[v] = dep[u] + 1;
        lb[v][0].insert(w[u]);
        dfs(v);
    }
}

inline LL query(int x, int y) {
    LinearBasis res;
    if(x == y) {
        res.insert(w[x]); return res.max();
    }
    if(dep[x] > dep[y]) std::swap(x, y);
    int del = dep[y] - dep[x];
    for(int i = 14; i >= 0; i--) {
        if(del & (1 << i)) {
            res.merge(lb[y][i]);
            y = anc[y][i];
        }
    }
    if(x == y) return res.max();
    for(int i = 14; i >= 0; i--) {
        if(anc[x][i] != anc[y][i]) {
            res.merge(lb[x][i]);
            res.merge(lb[y][i]);
            x = anc[x][i];
            y = anc[y][i];
        }
    }
    res.merge(lb[x][0]);
    res.insert(w[y]);
    return res.max();
}

int n, q, x, y;

int main() {
    n = readint(); q = readint();
    for(int i = 1; i <= n; i++) {
        w[i] = readint();
        lb[i][0].insert(w[i]);
    }
    for(int i = 1; i < n; i++) {
        x = readint(); y = readint();
        gra[x].push_back(y);
        gra[y].push_back(x);
    }
    dfs(1);
    while(q--) {
        x = readint(); y = readint();
        printf("%lld\n", query(x, y));
    }
    return 0;
}
[HE/TJOI2016]排序 题解

[HE/TJOI2016]排序 题解

题目地址:洛谷:【P2824】[HEOI2016/TJOI2016]排序 –